/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_echo_cli.c,v 1.3.1.2 2006/07/11 00:58:27 abe Exp abe $
 */

/* 
 *  UDP ECHO 饤
 */

#include <string.h>

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/echo.h>

#ifdef USE_UDP_ECHO_CLI

/*
 * ѿ
 */

#define BUF_SIZE	2048

static UB		udp_buf[BUF_SIZE];
static T_IPEP		dst;

#ifdef USE_UDP_NON_BLOCKING

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_udp_echo_cli (ID cepid, FN fncd, VP p_parblk)
{
	ER_UINT		len;

	len = (ER_UINT)p_parblk;
	if (len < 0)	/* 0 ʲξϡ顼 */
		syslog(LOG_NOTICE, "[UEC:%02d CBR] fncd: %s, error: %s",
		                   cepid, in_strtfn(fncd), itron_strerror(len));
	else if (fncd == TFN_UDP_RCV_DAT) {
		udp_buf[len] = '\0';
		syslog(LOG_NOTICE, "[UEC:%02d RCV] received:           from: %s.%d, len: %d, msg: '%s'",
		                   cepid, IP2STR(NULL, &dst.ipaddr), dst.portno, len, udp_buf);
		}
	else if (fncd == TFN_UDP_SND_DAT)
		syscall(wup_tsk(UDP_ECHO_CLI_TASK));
	return E_OK;
	}

/*
 *  send_udp_echo -- ECHO/UDP Ф˥å (Υ֥å󥰥)
 */

static void
send_udp_echo (ID cepid, T_IN_ADDR *ipaddr, UB *line)
{
	UINT	len;
	ER_UINT	error;

	dst.ipaddr = *ipaddr;
	dst.portno = 7;
	len         = strlen(line);
	syslog(LOG_NOTICE, "[UEC:%02d SND] sending:            to:   %s.%d, len: %d, msg: '%s'",
	                   cepid, IP2STR(NULL, &dst.ipaddr), dst.portno, len, line);
	error = UDP_SND_DAT(cepid, &dst, (VP)line, len, TMO_NBLK);
	syscall(slp_tsk());
	error = UDP_RCV_DAT(cepid, &dst, (VP)udp_buf, sizeof(udp_buf), TMO_NBLK);
	}

#else	/* of #ifdef USE_UDP_NON_BLOCKING */

#ifdef USE_UDP_CALL_BACK

/*
 *  Хåؿ
 */

ER
callback_udp_echo_cli (ID cepid, FN fncd, VP p_parblk)
{
	ER_UINT	len;

	if ((len = UDP_RCV_DAT(cepid, &dst, (VP)udp_buf, sizeof(udp_buf), TMO_FEVR)) >= 0) {
		*(udp_buf + len) = '\0';
		syslog(LOG_NOTICE, "[UEC:%02d RCV] recv: addr: %s.%d, len: %d, msg: '%s'",
		                   cepid, IP2STR(NULL, &dst.ipaddr), dst.portno, len, udp_buf);
		}
	else
		syslog(LOG_NOTICE, "[UEC:%02d RCV] recv: error: %s", cepid, itron_strerror(len));

	return E_OK;
	}

/*
 *  send_udp_echo -- ECHO/UDP Ф˥å (Хåؿ)
 */

static void
send_udp_echo (ID cepid, T_IN_ADDR *ipaddr, UB *line)
{
	ER_UINT	len;

	dst.ipaddr = *ipaddr;
	dst.portno = 7;
	len        = strlen(line);
	syslog(LOG_NOTICE, "[UEC:%02d SND] sending:            to:   %s.%d, len: %d, msg: '%s'",
	                   cepid, IP2STR(NULL, &dst.ipaddr), dst.portno, len, line);
	if ((len = UDP_SND_DAT(cepid, &dst, (VP)line, len, TMO_FEVR)) < 0)
		syslog(LOG_NOTICE, "[UEC:%02d SND] error: %s", cepid, itron_strerror(len));

	}

#else	/* of #ifdef USE_UDP_CALL_BACK */

/*
 *  send_udp_echo -- ECHO/UDP Ф˥å (Хåؿ̤)
 */

static void
send_udp_echo (ID cepid, T_IN_ADDR *ipaddr, UB *line)
{
	ER_UINT	len;

	dst.ipaddr = *ipaddr;
	dst.portno = 7;
	len         = strlen(line);
	syslog(LOG_NOTICE, "[UEC:%02d SND] sending:            to:   %s.%d, len: %d, msg: '%s'",
	                   cepid, IP2STR(NULL, &dst.ipaddr), dst.portno, len, line);
	if ((len = UDP_SND_DAT(cepid, &dst, (VP)line, len, TMO_FEVR)) < 0)
		syslog(LOG_NOTICE, "[UEC:%02d SND] error: %s", cepid, itron_strerror(len));

	if ((len = UDP_RCV_DAT(cepid, &dst, (VP)udp_buf, sizeof(udp_buf), 10*1000)) >= 0) {
		*(udp_buf + len) = '\0';
		syslog(LOG_NOTICE, "[UEC:%02d RCV] received:           from: %s.%d, len: %d, msg: '%s'",
		                   cepid, IP2STR(NULL, &dst.ipaddr), dst.portno, len, line);
		}
	else
		syslog(LOG_NOTICE, "[UEC:%02d RCV] error: %s", cepid, itron_strerror(len));
	}

#endif	/* of #ifdef USE_UDP_CALL_BACK */

#endif	/* of #ifdef USE_UDP_NON_BLOCKING */

/*
 *  UDP ECHO 饤
 */

void
udp_echo_cli_task (VP_INT exinf)
{
	T_IN_ADDR	addr;
	UB		*line;
	ID		tskid;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP ECHO CLI:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (rcv_dtq(DTQ_UDP_ECHO_CLI, (VP_INT*)(VP)&line) == E_OK) {
			line = skip_blanks(GET_IPADDR(&addr, skip_blanks(line)));
			send_udp_echo((ID)exinf, &addr, line);
			}
		}
	}

#endif	/* of #ifdef USE_UDP_ECHO_CLI */
