/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: in_subr.c,v 1.3.1.2 2006/07/11 00:56:52 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_loop.h>
#include <net/if_ppp.h>
#include <net/ethernet.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet6/in6.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/tcp_timer.h>

#include <net/if_var.h>

#ifdef SUPPORT_INET4

/*
 *  ip2str -- IPv4 ɥ쥹ʸѴ롣
 */

UB *
ip2str (UB *buf, const T_IN4_ADDR *ipaddr)
{
	static UB	addr_sbuf[NUM_IPV4ADDR_STR_BUFF][sizeof("123.123.123.123")];
	static int	bix = NUM_IPV4ADDR_STR_BUFF;

	UB *start;

	if (buf == NULL) {
		syscall(wai_sem(SEM_IP2STR_BUFF_LOCK));
		buf = addr_sbuf[-- bix];
		if (bix <= 0)
			bix = NUM_IPV4ADDR_STR_BUFF;
		syscall(sig_sem(SEM_IP2STR_BUFF_LOCK));
		}

	start = buf;
	buf += convert_hexdigit(buf, (int)((*ipaddr >> 24) & 0xff), 10, 0, FALSE, ' ');
	*(buf ++) = '.';
	buf += convert_hexdigit(buf, (int)((*ipaddr >> 16) & 0xff), 10, 0, FALSE, ' ');
	*(buf ++) = '.';
	buf += convert_hexdigit(buf, (int)((*ipaddr >>  8) & 0xff), 10, 0, FALSE, ' ');
	*(buf ++) = '.';
	buf += convert_hexdigit(buf, (int)((*ipaddr      ) & 0xff), 10, 0, FALSE, ' ');
	*buf = '\0';
	return start;
	}

/*
 *  in4_set_header -- IPv4 إåꤹ롣
 */

ER
in4_set_header (T_NET_BUF *nbuf, UINT len,
                T_IN4_ADDR *dstaddr, T_IN4_ADDR *srcaddr, UB proto, UB ttl)
{
	T_IP4_HDR	*ip4h = GET_IP4_HDR(nbuf);
	T_IFNET		*ifp = IF_GET_IFNET();

	/* IP إåꤹ롣*/
	ip4h->vhl	= IP4_MAKE_VHL(IPV4_VERSION, IP4_HDR_SIZE >> 2);
	ip4h->len	= htons(IP4_HDR_SIZE + len);
	ip4h->proto	= proto;
	ip4h->ttl	= ttl;
	ip4h->type	= 0;
	ip4h->id	= ip4h->flg_off = ip4h->sum = 0;

	/* IP ɥ쥹ꤹ롣*/
	ip4h->dst	= htonl(*dstaddr);

	if (srcaddr == NULL || *srcaddr == IPV4_ADDRANY)
		ip4h->src = htonl(ifp->in_ifaddr.addr);
	else
		ip4h->src = htonl(*srcaddr);

	return E_OK;
	}

/*
 *  in4_get_datagram -- IPv4 ǡإåꤹ롣
 */

ER
in4_get_datagram (T_NET_BUF **nbuf, UINT len, UINT maxlen,
                  T_IN4_ADDR *dstaddr, T_IN4_ADDR *srcaddr,
                  UB proto, UB ttl, ATR nbatr, TMO tmout)
{
	ER	error;
	UINT	align;

	/* ǡĹ 4 ƥåȶĴ롣*/
	align = (len + 3) >> 2 << 2;

	/* ͥåȥХåե롣*/
	if ((error = tget_net_buf_ex(nbuf, (UINT)(IF_IP4_HDR_SIZE + align),
	                                   (UINT)(IF_IP4_HDR_SIZE + maxlen), nbatr, tmout)) != E_OK)
		return error;

	/*
	 *  礭ʥΥͥåȥХåեΤĹĴ롣
	 *  꾮ʥΥͥåȥХåեγϡɥХåե
	 *  ʥԡǽǻѤ졢ºݤޤǡǡϷǤʤ
	 */
	if ((nbatr & NBA_SEARCH_ASCENT) != 0)
		(*nbuf)->len = (UH)(IF_IP4_HDR_SIZE + len);

	/* 4 ƥåȶޤǥѥǥ󥰤롣*/
	if (align > len)
		memset((VP)(GET_IP4_SDU(*nbuf) + len), 0, (size_t)(align - len));

	/* IP إåꤹ롣*/
	return in4_set_header(*nbuf, len, dstaddr, srcaddr, proto, ttl);
	}

/*
 *  in4_cksum -- IPv4 Υȥ󥹥ݡإإåΥå׻롣
 *
 *  : ͤϥͥåȥХȥ
 */

UH
in4_cksum (T_NET_BUF *nbuf, UB proto, UINT off, UINT len)
{
	UW	sum;
	UINT	align;

	/* 4 ƥåȶΥǡĹ */
	align = (len + 3) >> 2 << 2;

	/* 4 ƥåȶޤǥѥǥ󥰤롣*/
	if (align > len)
		memset((VP)((UB*)nbuf->buf + off + len), 0, (size_t)(align - len));

	sum = in_cksum_sum(nbuf->buf + off, align)
	    + in_cksum_sum(&GET_IP4_HDR(nbuf)->src, sizeof(T_IN4_ADDR) * 2)
	    + len + proto;
	sum = in_cksum_carry(sum);

	return (UH)(~htons((UH)sum));
	}

/*
 *  in_cksum -- å׻ؿIPv4ICMPv4 
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 *
 *        ͤϥͥåȥХȥ
 */

UH
in_cksum (VP data, UINT len /*ƥåñ*/)
{
	UH	sum;

	sum = (UH)in_cksum_carry(in_cksum_sum(data, len));
	return (UH)(~htons(sum));
	}

/*
 *  in4_is_dstaddr_accept -- 襢ɥ쥹Ȥå롣
 *
 *    : dstaddr ϡ
 *          TINET-1.2 ͥåȥХȥ
 *          TINET-1.1 ޤǤϡۥȥХȥ
 */

BOOL
in4_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_IN4_ADDR *dstaddr)
{
	if (*myaddr == IPV4_ADDRANY)
		return ntohl(*dstaddr) == IF_GET_IFNET()->in_ifaddr.addr;
	else
		return ntohl(*dstaddr) == *myaddr;
	}

/*
 * in4_ifawithifp -- 襢ɥ쥹ˤդ路ɥ쥹
 *                   ͥåȥ󥿥եõ롣
 *                   in6_ifawithifp 򥷥ߥ졼Ȥǡ
 *                   顼֤ȤϤʤ
 */

T_IN4_IFADDR *
in4_ifawithifp (T_IFNET *ifp, T_IN4_ADDR *dst)
{
	return &ifp->in_ifaddr;
	}

/*
 *  in4_add_ifaddr -- 󥿥ե IPv4 ɥ쥹ꤹ롣
 */

ER
in4_add_ifaddr (T_IN4_ADDR addr, T_IN4_ADDR mask)
{
	T_IFNET	*ifp = IF_GET_IFNET();

	ifp->in_ifaddr.addr = addr;
	ifp->in_ifaddr.mask = mask;
	return E_OK;
	}

#if NUM_ROUTE_ENTRY > 0

/*
 *  in4_add_route -- ϩɽ˥ȥꤹ롣
 */

ER
in4_add_route (int index, T_IN4_ADDR target, T_IN4_ADDR mask, T_IN4_ADDR gateway)
{

	if (0 <= index && index < NUM_STATIC_ROUTE_ENTRY) {
		routing_tbl[index].target  = target;
		routing_tbl[index].mask    = mask;
		routing_tbl[index].gateway = gateway;
		return E_OK;
		}
	else
		return E_PAR;
	}

#endif	/* of #if NUM_ROUTE_ENTRY > 0 */

/*
 *  in4_rtalloc -- 롼ƥɽõ롣
 */

T_IN4_ADDR
in4_rtalloc (T_IN4_ADDR dst)
{
	int ix;

	for (ix = NUM_ROUTE_ENTRY; ix --; )
		if ((routing_tbl[ix].flags & IN_RTF_DEFINED) &&
		    (dst & routing_tbl[ix].mask) == routing_tbl[ix].target) {
			if (routing_tbl[ix].gateway == 0)
				return dst;
			else {
				return routing_tbl[ix].gateway;
				}
			}
	return dst;
	}

#if NUM_REDIRECT_ROUTE_ENTRY > 0

/*
 *  in4_rtredirect -- 롼ƥɽ˥ȥϿ롣
 *
 *    :  tmo ñ̤ [ms]
 */

void
in4_rtredirect (T_IN4_ADDR gateway, T_IN4_ADDR target, UB flags, UW tmo)
{
	T_IN_RTENTRY	*frt;

	frt = in_rtnewentry(flags, tmo);
	frt->gateway    = gateway;
	frt->target     = target;
	frt->mask       = 0xffffffff;
	}

#endif	/* of #if NUM_REDIRECT_ROUTE_ENTRY > 0 */

/*
 *  in4_timer -- IPv4 ̥ޡ
 *
 *    1üǵư롣
 */

static void
in4_timer (void)
{
#if NUM_REDIRECT_ROUTE_ENTRY > 0

	in_rttimer();

#endif	/* of #if NUM_REDIRECT_ROUTE_ENTRY > 0 */

#ifdef IP4_CFG_FRAGMENT

	ip_frag_timer();

#endif	/* of #ifdef IP4_CFG_FRAGMENT */

	timeout((FP)in4_timer, NULL, IN_TIMER_TMO);
	}

/*
 *  in4_init -- IPv4 ̵ǽ롣
 */

void
in4_init (void)
{
#if NUM_REDIRECT_ROUTE_ENTRY > 0

	in_rtinit();

#endif	/* of #if NUM_REDIRECT_ROUTE_ENTRY > 0 */

	timeout((FP)in4_timer, NULL, IN_TIMER_TMO);
	}

#endif	/* of #ifdef SUPPORT_INET4 */

#if NUM_REDIRECT_ROUTE_ENTRY > 0

/*
 *  in_rtinit -- 롼ƥɽ롣
 */

void
in_rtinit (void)
{
	int ix;

	for (ix = 0; ix < NUM_STATIC_ROUTE_ENTRY; ix ++)
		routing_tbl[ix].flags = IN_RTF_DEFINED;

	for ( ; ix < NUM_ROUTE_ENTRY; ix ++)
		routing_tbl[ix].flags = 0;
	}

/*
 *  in_rtnewentry -- ȥ롣
 */

T_IN_RTENTRY *
in_rtnewentry (UB flags, UW tmo)
{
	SYSTIM		now;
	T_IN_RTENTRY	*rt, *frt = NULL;
	int		ix;

	/* ȥõ*/
	for (ix = NUM_STATIC_ROUTE_ENTRY; ix < NUM_ROUTE_ENTRY; ix ++) {
		rt = &routing_tbl[ix];
		if ((routing_tbl[ix].flags & IN_RTF_DEFINED) == 0) {
			frt = rt;
			break;
			}
		}

	/* expire ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	if (frt == NULL) {
		/* ʤС֤ͭäȤûȥˤ롣*/
		T_IN_RTENTRY	*srt = NULL;
		INT		diff, sdiff = INT_MAX;

		syscall(wai_sem(SEM_IN_ROUTING_TBL));
		for (ix = NUM_STATIC_ROUTE_ENTRY; ix < NUM_ROUTE_ENTRY; ix ++) {
			rt = &routing_tbl[ix];
			diff = (INT)(rt->expire - now);
			if (diff <= 0) {	/* rt->expire <= now */
				/* ˡ֤ͭ᤮Ƥ롣*/
				frt = rt;
				break;
				}
			else if (diff < sdiff) {
				srt = rt;
				sdiff = diff;
				}
			}
		if (frt == NULL)
			frt = srt;
		frt->flags = 0;
		syscall(sig_sem(SEM_IN_ROUTING_TBL));
		}

	frt->flags  = (UB)(flags | IN_RTF_DEFINED);
	frt->expire = now + tmo / SYSTIM_HZ;
	return frt;
	}

/*
 *  in_rttimer -- 롼ƥɽδޡ
 */

void
in_rttimer (void)
{
	SYSTIM	now;
	int	ix;

	/* expire ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	syscall(wai_sem(SEM_IN_ROUTING_TBL));
	for (ix = NUM_STATIC_ROUTE_ENTRY; ix < NUM_ROUTE_ENTRY; ix ++)
		if ((routing_tbl[ix].flags & IN_RTF_DEFINED) &&
		    (INT)(routing_tbl[ix].expire - now) <= 0)
			routing_tbl[ix].flags = 0;
	syscall(sig_sem(SEM_IN_ROUTING_TBL));
	}

#endif	/* of #if NUM_REDIRECT_ROUTE_ENTRY > 0 */

/*
 *  in_cksum_sum -- åι׷׻ؿ
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 *
 *        ͤϥۥȥХȥ
 */

UW
in_cksum_sum (VP data, UINT len /*ƥåñ*/)
{
	UW sum = 0;

	for ( ; len > 0; len -= 2) {
		sum += ntohs(*((UH*)data));
		data = (VP)((UB*)data + 2);
		}

	return sum;
	}

/*
 *  in_cksum_carry -- åη夲׻ؿ
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 */

UW
in_cksum_carry (UW sum)
{
	UW	carry;

	while (sum >= 0x00010000) {
		carry = sum >> 16;
		sum   = (sum & 0xffff) + carry;
		}

	return sum;
	}

/*
 *  in_strtfn -- API ǽɤʸɽ֤
 */

const char *
in_strtfn (FN fncd)
{
	switch (fncd) {

	/* TCP ط */

	case TFN_TCP_CRE_REP:
		return "TFN_TCP_CRE_REP";
		break;
	case TFN_TCP_DEL_REP:
		return "TFN_TCP_DEL_REP";
		break;
	case TFN_TCP_CRE_CEP:
		return "TFN_TCP_CRE_CEP";
		break;
	case TFN_TCP_DEL_CEP:
		return "TFN_TCP_DEL_CEP";
		break;
	case TFN_TCP_ACP_CEP:
		return "TFN_TCP_ACP_CEP";
		break;
	case TFN_TCP_CON_CEP:
		return "TFN_TCP_CON_CEP";
		break;
	case TFN_TCP_SHT_CEP:
		return "TFN_TCP_SHT_CEP";
		break;
	case TFN_TCP_CLS_CEP:
		return "TFN_TCP_CLS_CEP";
		break;
	case TFN_TCP_SND_DAT:
		return "TFN_TCP_SND_DAT";
		break;
	case TFN_TCP_RCV_DAT:
		return "TFN_TCP_RCV_DAT";
		break;
	case TFN_TCP_GET_BUF:
		return "TFN_TCP_GET_BUF";
		break;
	case TFN_TCP_SND_BUF:
		return "TFN_TCP_SND_BUF";
		break;
	case TFN_TCP_RCV_BUF:
		return "TFN_TCP_RCV_BUF";
		break;
	case TFN_TCP_REL_BUF:
		return "TFN_TCP_REL_BUF";
		break;
	case TFN_TCP_SND_OOB:
		return "TFN_TCP_SND_OOB";
		break;
	case TFN_TCP_RCV_OOB:
		return "TFN_TCP_RCV_OOB";
		break;
	case TFN_TCP_CAN_CEP:
		return "TFN_TCP_CAN_CEP";
		break;
	case TFN_TCP_SET_OPT:
		return "TFN_TCP_SET_OPT";
		break;
	case TFN_TCP_GET_OPT:
		return "TFN_TCP_GET_OPT";
		break;
	case TFN_TCP_ALL:
		return "ALL";
		break;

	/* UDP ط */

	case TFN_UDP_CRE_CEP:
		return "TFN_UDP_CRE_CEP";
		break;
	case TFN_UDP_DEL_CEP:
		return "TFN_UDP_DEL_CEP";
		break;
	case TFN_UDP_SND_DAT:
		return "TFN_UDP_SND_DAT";
		break;
	case TFN_UDP_RCV_DAT:
		return "TFN_UDP_RCV_DAT";
		break;
	case TFN_UDP_CAN_CEP:
		return "TFN_UDP_CAN_CEP";
		break;
	case TFN_UDP_SET_OPT:
		return "TFN_UDP_SET_OPT";
		break;
	case TFN_UDP_GET_OPT:
		return "TFN_UDP_GET_OPT";
		break;

	default:
		return "unknown TFN";
		}
	}
