/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_var.h,v 1.3.1.2 2006/07/11 00:56:52 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1993, 1994, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)tcp_var.h	8.4 (Berkeley) 5/24/95
 * $FreeBSD: src/sys/netinet/tcp_var.h,v 1.49.2.1 1999/08/29 16:29:57 peter Exp $
 */
 
#ifndef _TCP_VAR_H_
#define _TCP_VAR_H_

/*
 *  TCP إåڥɥޥ
 */

#define IP_TCP_HDR_SIZE			(IP_HDR_SIZE + TCP_HDR_SIZE)
#define IF_IP_TCP_HDR_SIZE		(IF_IP_HDR_SIZE + TCP_HDR_SIZE)
#define IF_IP_TCP_HDR_OFFSET		(IF_IP_HDR_SIZE)
#define IF_IP_TCP_SDU_OFFSET		(IF_IP_TCP_HDR_SIZE)

#define GET_TCP_HDR(nbuf,thoff)		((T_TCP_HDR*)((UB*)((nbuf)->buf) + thoff))
#define GET_TCP_OPT(nbuf,thoff)		((UB*)((nbuf)->buf) + thoff + TCP_HDR_SIZE)
#define GET_TCP_SDU(nbuf,thoff)		((UB*)((nbuf)->buf) + thoff + GET_TCP_HDR_SIZE2(nbuf,thoff))

#define GET_TCP_HDR_OFFSET(nbuf)	(GET_IF_IP_HDR_SIZE(nbuf))

#define GET_TCP_HDR_SIZE2(nbuf,thoff)	(TCP_HDR_LEN(GET_TCP_HDR(nbuf,thoff)->doff))
#define GET_IP_TCP_HDR_SIZE2(nbuf,thoff) \
					(GET_IP_HDR_SIZE(GET_IP_HDR(nbuf)) + GET_TCP_HDR_SIZE2(nbuf,thoff))
#define GET_IF_IP_TCP_HDR_SIZE2(nbuf,thoff) \
					(IF_HDR_SIZE + GET_IP_TCP_HDR_SIZE2(nbuf,thoff))

/*
 *  TINET 1.1 ȤθߴΤ
 */

#ifdef SUPPORT_INET4

#define IP4_TCP_HDR_SIZE		IP_TCP_HDR_SIZE
#define IF_IP4_TCP_HDR_SIZE		IF_IP_TCP_HDR_SIZE
#define GET_IP4_TCP_HDR_SIZE(nbuf)	GET_IP_TCP_HDR_SIZE(nbuf)	
#define GET_IF_IP4_TCP_HDR_SIZE(nbuf)	GET_IF_IP_TCP_HDR_SIZE(nbuf)	

#endif	/* of #ifdef SUPPORT_INET4 */

/*
 *  TCP ո
 */

#ifdef SUPPORT_INET4

typedef struct t_tcp_crep {
	/* ɸ */
	ATR		repatr;		/* ո°		*/
	T_IPV4EP	myaddr;		/* ʬΥɥ쥹	*/
	/* ¸ */
	} T_TCP_CREP;

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

typedef struct t_tcp6_crep {
	/* ɸ */
	ATR		repatr;		/* ո°		*/
	T_IPV6EP	myaddr;		/* ʬΥɥ쥹	*/
	/* ¸ */
	} T_TCP6_CREP;

#define T_TCP_CREP	T_TCP6_CREP

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  TCP ̿ü
 */

typedef UW T_TCP_SEQ;
typedef UH T_TCP_SEG;
typedef UH T_TCP_WND;

#ifdef SUPPORT_INET4

typedef struct t_tcp_ccep {
	/* ɸ */
	ATR		cepatr;		/* ̿ü°			*/
	VP		sbuf;		/* ѥɥХåե	*/
	INT		sbufsz;		/* ѥɥХåե	*/
	VP		rbuf;		/* ѥɥХåե	*/
	INT		rbufsz;		/* ѥɥХåե	*/
	FP		callback;	/* Хå			*/
	/* ¸ */
	ID		semid_lock;	/* ̿üå		*/
	ID		est_flgid;	/* ֥ͥ٥ȥե饰*/
	ID		snd_flgid;	/* ٥ȥե饰		*/
	ID		rcv_flgid;	/* ٥ȥե饰		*/
	ID		snd_tskid;	/* ̻		*/
	ID		rcv_tskid;	/* ̻		*/
	UB		*sbuf_rptr;	/* ɤ߽Фݥ	*/
	UB		*sbuf_wptr;	/* ѽ񤭹ߥݥ	*/
	UB		*rbuf_rptr;	/* ɤ߽Фݥ	*/
	UB		*rbuf_wptr;	/* ѽ񤭹ߥݥ	*/
	T_TCP_SEQ	snd_ssthresh;	/* ԥɥ(snd_cwnd)	*/
					/* Τ			*/
	T_TCP_TIME	rxtcur;		/* ߤκॢ	*/
	T_TCP_TIME	srtt;		/* ʿ경줿 RTT		*/
	T_TCP_TIME	rttvar;		/* ʿ경줿ʬ		*/
	T_TCP_WND	snd_cwnd;	/* ԥɥ		*/

	/*
	 *  κȥ	
	 *
	 *    ꥸʥǤϡ̤ΥȤκ祵 (t_maxseg) ȡ
	 *    ץդΥȤκ祵 (t_maxopd) ̤
	 *    ʤäƤ롣ϡߤΥ󥿡ͥåȤǤϡץդ
	 *    ȤΤۤ¿Ƥ뤿Ǥ롣
	 *    ܼǤϡ祻ȥץʳΥץ
	 *    ʤΤǡt_maxseg λѤ롣
	 */
	T_TCP_SEG	maxseg;

	T_IPV4EP 	*p_dstaddr;	/* Υɥ쥹ؤΥݥ	*/
	T_IPV4EP 	*p_myaddr;	/* ʬΥɥ쥹ؤΥݥ	*/
	H		snd_tfn;	/* ư API ǽ	*/
	H		rcv_tfn;	/* ư API ǽ	*/

#ifdef TCP_CFG_NON_BLOCKING

	H		snd_nblk_tfn;	/* ư API ǽ	*/
	H		rcv_nblk_tfn;	/* ư API ǽ	*/
	VP		snd_data;	/* ǡΰƬɥ쥹	*/
	INT		snd_len;	/* ǡΰĹ		*/
	VP		rcv_data;	/* ǡΰƬɥ쥹	*/
	INT		rcv_len;	/* ǡΰĹ		*/
	VP	 	*snd_p_buf;	/* ХåեؤΥݥ	*/
	VP	 	*rcv_p_buf;	/* ХåեؤΥݥ	*/

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

#ifdef TCP_CFG_SWBUF_CSAVE
	T_NET_BUF	*swbufq;	/* ɥХåե塼	*/
#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */

	UH		flags;		/* ̿üե饰		*/

	/*
	 *  ʹߤΥС tcp_init_cep() ؿǥꥢ롣
	 */

	T_TCP_TIME	timer[NUM_TCP_TIMERS];	/* TCP Υ		*/
	T_IPV4EP	dstaddr;	/* Υɥ쥹		*/
	T_IPV4EP	myaddr;		/* ʬΥɥ쥹		*/
	T_TCP_CREP	*rep;		/* ո			*/
	T_NET_BUF	*reassq;	/* ƹ塼		*/

#ifdef TCP_CFG_RWBUF_CSAVE
	T_NET_BUF	*rwbufq;	/* ɥХåե塼	*/
#endif	/* of #ifdef TCP_CFG_RWBUF_CSAVE */

	T_TCP_SEQ	snd_una;	/* ̤ǧκǾ SEQ Ĥޤ	*/
					/* ǧ줿 SEQ	*/
	T_TCP_SEQ	snd_max;	/*  SEQ		*/
	T_TCP_SEQ	snd_nxt;	/*  SEQ		*/
	T_TCP_SEQ	snd_up;		/* ۵ޥݥ		*/
	T_TCP_SEQ	snd_wl1;	/* 󥦥ɤ򹹿 SEQ	*/
	T_TCP_SEQ	snd_wl2;	/* 󥦥ɤ򹹿 ACK	*/
	T_TCP_SEQ	iss;		/* ʬ SEQ ν		*/
	T_TCP_SEQ	irs;		/*  SEQ ν		*/
	T_TCP_SEQ	rcv_nxt;	/* ԤƤǾ SEQ	*/
	T_TCP_SEQ	rcv_adv;	/* ԤƤ SEQ	*/
	T_TCP_SEQ	rcv_wnd;	/* ǽʥɥ	*/
	T_TCP_SEQ	rcv_up;		/* ۵ޥݥ		*/
	T_TCP_SEQ	rtseq;		/* ַ¬Ϥ᤿ SEQ		*/
	T_TCP_SEQ	last_ack_sent;	/* Ǹ ACK		*/
	T_TCP_TIME	idle;		/* ɥ			*/
	ER		error;		/* Ʊȯ顼	*/
	ER		net_error;	/* ͥåȥΥ顼	*/
	T_TCP_WND	snd_wnd;	/* μǽɥ	*/
	T_TCP_WND	max_sndwnd;	/* ޤǤκɥ*/
	T_TCP_TIME	rtt;		/* 			*/
	UH		swbuf_count;	/* ɥХåեλ極	*/
	UH		rwbuf_count;	/* ɥХåեλ極	*/
	UH		rcv_buf_len;	/* tcp_rcv_buf γĹ	*/
	UH		get_buf_len;	/* tcp_rcv_buf γĹ	*/
	UB		rxtshift;	/*  log(2)		*/
	UB		fsm_state;	/* FSM 			*/
	UB		dupacks;	/*  ACK 			*/

#if defined(TCP_CFG_RWBUF_CSAVE) && defined(TCP_CFG_RWBUF_CSAVE_MAX_QUEUES)
	UB		rwbufq_entries;	/* ɥХåե塼Υȥ	*/
#endif	/* of #if defined(TCP_CFG_RWBUF_CSAVE) && defined(TCP_CFG_RWBUF_CSAVE_MAX_QUEUES) */

	} T_TCP_CCEP;

/* Time Wait  TCP ̿ü */

typedef struct t_tcp4_tw_ccep {
	INT		rbufsz;		/* ѥɥХåե	*/
	T_TCP_TIME	timer_2msl;	/* 2MSL 			*/
	T_IPV4EP	dstaddr;	/* Υɥ쥹		*/
	T_IPV4EP	myaddr;		/* ʬΥɥ쥹		*/
	T_TCP_SEQ	snd_una;	/* ̤ǧκǾ SEQ Ĥޤ	*/
					/* ǧ줿 SEQ	*/
	T_TCP_SEQ	iss;		/* ʬ SEQ ν		*/
	T_TCP_SEQ	irs;		/*  SEQ ν		*/
	T_TCP_SEQ	rcv_nxt;	/* ԤƤǾ SEQ	*/
	T_TCP_WND	snd_wnd;	/* μǽɥ	*/
	UH		rwbuf_count;	/* ɥХåեλ極	*/
	UB		fsm_state;	/* FSM 			*/

	} T_TCP4_TW_CCEP;

#define T_TCP_TW_CCEP	T_TCP4_TW_CCEP

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

typedef struct t_tcp6_ccep {
	/* ɸ */
	ATR		cepatr;		/* ̿ü°			*/
	VP		sbuf;		/* ѥɥХåե	*/
	INT		sbufsz;		/* ѥɥХåե	*/
	VP		rbuf;		/* ѥɥХåե	*/
	INT		rbufsz;		/* ѥɥХåե	*/
	FP		callback;	/* Хå			*/
	/* ¸ */
	ID		semid_lock;	/* ̿üå		*/
	ID		est_flgid;	/* ֥ͥ٥ȥե饰*/
	ID		snd_flgid;	/* ٥ȥե饰		*/
	ID		rcv_flgid;	/* ٥ȥե饰		*/
	ID		snd_tskid;	/* ̻		*/
	ID		rcv_tskid;	/* ̻		*/
	UB		*sbuf_rptr;	/* ɤ߽Фݥ		*/
	UB		*sbuf_wptr;	/* ѽ񤭹ߥݥ		*/
	UB		*rbuf_rptr;	/* ɤ߽Фݥ		*/
	UB		*rbuf_wptr;	/* ѽ񤭹ߥݥ		*/
	T_TCP_SEQ	snd_ssthresh;	/* ԥɥ(snd_cwnd)	*/
					/* Τ			*/
	T_TCP_TIME	rxtcur;		/* ߤκॢ		*/
	T_TCP_TIME	srtt;		/* ʿ경줿 RTT		*/
	T_TCP_TIME	rttvar;		/* ʿ경줿ʬ		*/
	T_TCP_WND	snd_cwnd;	/* ԥɥ		*/

	/*
	 *  κȥ	
	 *
	 *    ꥸʥǤϡ̤ΥȤκ祵 (t_maxseg) ȡ
	 *    ץդΥȤκ祵 (t_maxopd) ̤
	 *    ʤäƤ롣ϡߤΥ󥿡ͥåȤǤϡץդ
	 *    ȤΤۤ¿Ƥ뤿Ǥ롣
	 *    ܼǤϡ祻ȥץʳΥץ
	 *    ʤΤǡt_maxseg λѤ롣
	 */
	T_TCP_SEG	maxseg;

	T_IPV6EP 	*p_dstaddr;	/* Υɥ쥹ؤΥݥ	*/
	T_IPV6EP 	*p_myaddr;	/* ʬΥɥ쥹ؤΥݥ	*/
	H		snd_tfn;	/* ư API ǽ	*/
	H		rcv_tfn;	/* ư API ǽ	*/

#ifdef TCP_CFG_NON_BLOCKING

	H		snd_nblk_tfn;	/* ư API ǽ	*/
	H		rcv_nblk_tfn;	/* ư API ǽ	*/
	VP		snd_data;	/* ǡΰƬɥ쥹	*/
	INT		snd_len;	/* ǡΰĹ		*/
	VP		rcv_data;	/* ǡΰƬɥ쥹	*/
	INT		rcv_len;	/* ǡΰĹ		*/
	VP	 	*snd_p_buf;	/* ХåեؤΥݥ	*/
	VP	 	*rcv_p_buf;	/* ХåեؤΥݥ	*/

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

#ifdef TCP_CFG_SWBUF_CSAVE
	T_NET_BUF	*swbufq;	/* ɥХåե塼	*/
#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */

	UH		flags;		/* ̿üե饰		*/

	/*
	 *  ʹߤΥС tcp_init_cep() ؿǥꥢ롣
	 */

	T_TCP_TIME	timer[NUM_TCP_TIMERS];	/* TCP Υ		*/
	T_IPV6EP	dstaddr;	/* Υɥ쥹		*/
	T_IPV6EP	myaddr;		/* ʬΥɥ쥹		*/
	T_TCP6_CREP	*rep;		/* ո			*/
	T_NET_BUF	*reassq;	/* ƹ塼		*/

#ifdef TCP_CFG_RWBUF_CSAVE
	T_NET_BUF	*rwbufq;	/* ɥХåե塼	*/
#endif	/* of #ifdef TCP_CFG_RWBUF_CSAVE */

	T_TCP_SEQ	snd_una;	/* ̤ǧκǾ SEQ Ĥޤ	*/
					/* ǧ줿 SEQ	*/
	T_TCP_SEQ	snd_max;	/*  SEQ		*/
	T_TCP_SEQ	snd_nxt;	/*  SEQ		*/
	T_TCP_SEQ	snd_up;		/* ۵ޥݥ		*/
	T_TCP_SEQ	snd_wl1;	/* 󥦥ɤ򹹿 SEQ	*/
	T_TCP_SEQ	snd_wl2;	/* 󥦥ɤ򹹿 ACK	*/
	T_TCP_SEQ	iss;		/* ʬ SEQ ν		*/
	T_TCP_SEQ	irs;		/*  SEQ ν		*/
	T_TCP_SEQ	rcv_nxt;	/* ԤƤǾ SEQ	*/
	T_TCP_SEQ	rcv_adv;	/* ԤƤ SEQ	*/
	T_TCP_SEQ	rcv_wnd;	/* ǽʥɥ	*/
	T_TCP_SEQ	rcv_up;		/* ۵ޥݥ		*/
	T_TCP_SEQ	rtseq;		/* ַ¬Ϥ᤿ SEQ		*/
	T_TCP_SEQ	last_ack_sent;	/* Ǹ ACK		*/
	T_TCP_TIME	idle;		/* ɥ			*/
	ER		error;		/* Ʊȯ顼		*/
	ER		net_error;	/* ͥåȥΥ顼	*/
	T_TCP_WND	snd_wnd;	/* μǽɥ	*/
	T_TCP_WND	max_sndwnd;	/* ޤǤκɥ	*/
	T_TCP_TIME	rtt;		/* 			*/
	UH		swbuf_count;	/* ɥХåեλ極	*/
	UH		rwbuf_count;	/* ɥХåեλ極	*/
	UH		rcv_buf_len;	/* tcp_rcv_buf γĹ	*/
	UH		get_buf_len;	/* tcp_rcv_buf γĹ	*/
	UB		rxtshift;	/*  log(2)		*/
	UB		fsm_state;	/* FSM 			*/
	UB		dupacks;	/*  ACK 			*/

#if defined(TCP_CFG_RWBUF_CSAVE) && defined(TCP_CFG_RWBUF_CSAVE_MAX_QUEUES)
	UB		rwbufq_entries;	/* ɥХåե塼Υȥ	*/
#endif	/* of #if defined(TCP_CFG_RWBUF_CSAVE) && defined(TCP_CFG_RWBUF_CSAVE_MAX_QUEUES) */

	} T_TCP6_CCEP;

/* Time Wait  TCP ̿ü */

typedef struct t_tcp6_tw_ccep {
	INT		rbufsz;		/* ѥɥХåե	*/
	T_TCP_TIME	timer_2msl;	/* 2MSL 			*/
	T_IPV6EP	dstaddr;	/* Υɥ쥹		*/
	T_IPV6EP	myaddr;		/* ʬΥɥ쥹		*/
	T_TCP_SEQ	snd_una;	/* ̤ǧκǾ SEQ Ĥޤ	*/
					/* ǧ줿 SEQ	*/
	T_TCP_SEQ	iss;		/* ʬ SEQ ν		*/
	T_TCP_SEQ	irs;		/*  SEQ ν		*/
	T_TCP_SEQ	rcv_nxt;	/* ԤƤǾ SEQ	*/
	T_TCP_WND	snd_wnd;	/* μǽɥ	*/
	UH		rwbuf_count;	/* ɥХåեλ極	*/
	UB		fsm_state;	/* FSM 			*/

	} T_TCP6_TW_CCEP;

#define T_TCP_CCEP	T_TCP6_CCEP
#define T_TCP_TW_CCEP	T_TCP6_TW_CCEP

#endif	/* of #ifdef SUPPORT_INET6 */

#define T_TCP_CCEP_DEFINED

/*
 *  ̿üե饰
 */

#define CEP_FLG_ACK_NOW		0x0001	/* ľ ACK 롣	*/
#define CEP_FLG_DEL_ACK		0x0002	/* ACK ٱ䤹롣		*/
#define CEP_FLG_SENT_FIN	0x0004	/* FIN äƤ롣		*/
#define CEP_FLG_NEED_SYN	0x0008	/* SYN 롣		*/
#define CEP_FLG_NEED_FIN	0x0010	/* FIN 롣		*/
#define CEP_FLG_FORCE		0x0020	/* 			*/
#define CEP_FLG_NO_PUSH		0x0040	/* push ʤ		*/
#define CEP_FLG_NO_DELAY	0x0080	/* ٱ䤷ʤ			*/
#define CEP_FLG_FORCE_CLEAR	0x0100	/* ե饰򥯥ꥢ롣*/
#define CEP_FLG_POST_OUTPUT	0x0200	/* 򳫻Ϥ롣		*/
#define CEP_FLG_CLOSE_OUTPUT	0x0800	/* 女ͥĤ롣*/

/* ɥХåեξʥԡǽ */
#define CEP_FLG_WBCS_NBUF_REQ	0x8000	/* ͥåȥХåե׵*/
#define CEP_FLG_WBCS_MASK	0x7000	/* ޥ			*/
#define CEP_FLG_WBCS_FREE	0x0000	/* ɥХåե̤	*/
#define CEP_FLG_WBCS_WOPEN_PEND	0x1000	/* μɤγԤ	*/
#define CEP_FLG_WBCS_NBUF_PEND	0x2000	/* ͥåȥХåեͽԤ	*/
#define CEP_FLG_WBCS_NBUF_RSVD	0x3000	/* ͥåȥХåեͽѤ	*/
#define CEP_FLG_WBCS_NBUF_READY	0x4000	/* ͥåȥХåեƺѤ*/
#define CEP_FLG_WBCS_SEND_READY	0x5000	/* ǽ			*/
#define CEP_FLG_WBCS_SENT	0x6000	/* ѤߤǡACKԤ		*/
#define CEP_FLG_WBCS_ACKED	0x7000	/* ѤߤǡACKλ		*/

/*
 *  ̿ü٥ȥե饰
 */

#define CEP_EVT_ESTABLISHED	0x00000001	/* ͥΩ		*/
#define CEP_EVT_CLOSED		0x00000002	/* ̤Ѿ			*/
#define CEP_EVT_SWBUF_READY	0x00000004	/* ɥХåե	*/
#define CEP_EVT_RWBUF_READY	0x00000008	/* ɥХåեǡ*/
#define CEP_EVT_ALL		0xffffffff	/* ٥			*/

/*
 *  ɲ API ǽݥ
 */

/* TCP ط */

#define TFN_TCP_UNDEF		(0)

/*
 *  srtt:   ʿ경줿 RTT
 *  rttvar: ʿ경줿ʬ
 *  rtt:    ¬ꤵ줿
 *
 *  ʿ경줿 RTT (srtt) ʿ경줿ʬ (rttvar) 
 *  Ƿ׻뤿ˡեȤƥ뤹롣
 *  srtt  2 ʾʲ 3 ӥåȡ
 *  rttvar  2 ʾʲ 2 ӥåȤݻ롣
 */

#define TCP_DELTA_SHIFT		2
			/* ʬ = rtt/8 + srtt*7/8 η׻ΤΥե	*/
#define TCP_SRTT_SHIFT		(TCP_DELTA_SHIFT + 3)
					/* srtt Υե͡3(+2)ӥå	*/
#define TCP_RTTVAR_SHIFT	(TCP_DELTA_SHIFT + 2)
					/* rttvar Υե͡2(+2)ӥå	*/
#define TCP_SRTT_SCALE		(1<<TCP_SRTT_SHIFT)
#define TCP_RTTVAR_SCALE	(1<<TCP_RTTVAR_SHIFT)

/*
 *  ®ž򳫻Ϥ ACK Τ
 */

#define MAX_TCP_REXMT_THRESH	3

/*
 *  ƹ塼Ǥ TCP إå
 */

typedef struct t_tcp_q_hdr {
	UH	sport;		/* ݡֹ			*/
	UH	dport;		/* ݡֹ			*/

	UW	seq;		/* SEQ ֹ				*/

	T_NET_BUF *next;	/* Υȡ ACK ֹ(ack)	*/

	UB	doff;		/* ǡեå(4ӥå)	*/
	UB	flags;		/* ե饰(6ӥå)			*/
	UH	soff;		/* SDU եåȡϥɥ(win)*/

	UH	slen;		/* SDU Ĺϥå(sum)	*/
	UH	urp;		/* ۵ޥݥ				*/
	} T_TCP_Q_HDR;

#define GET_TCP_Q_HDR(nbuf,thoff)	((T_TCP_Q_HDR*)((UB*)((nbuf)->buf) + thoff))
#define GET_TCP_IP_Q_HDR(nbuf)		((T_TCP_IP_Q_HDR*)GET_IP_HDR(nbuf))

/*
 *  ֥ ID κǾͤ
 */

#define	TMIN_TCP_CREPID		1	/* TCP ո   ID κǾ			*/
#define	TMIN_TCP_CCEPID		1	/* TCP ̿ü ID κǾ			*/
#define	TMIN_TCP_TW_CCEPID	1	/* Time Wait  TCP ̿ü ID κǾ	*/

/*
 *  楻ȡʥǡʤ˥ΥͥåȥХåե
 */

typedef struct t_net_buf_cseg {
	UB	idix;			/* mpfid Υǥå	*/
	UB	flags;			/* ե饰		*/
	UH	len;			/* ǡĹ		*/
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB	align[4 - IF_HDR_ALIGN];
#endif
	UB	buf[IF_HDR_SIZE + IP_HDR_SIZE + TCP_HDR_SIZE];
					/* Хåե		*/
	} T_NET_BUF_CSEG;

#ifdef SUPPORT_MIB

/*
 *  SNMP  ١ (MIB)
 */

typedef struct t_tcp_stats {
	UW	tcpActiveOpens;
	UW	tcpPassiveOpens;
	UW	tcpAttemptFails;
	UW	tcpEstabResets;
/*	UW	tcpCurrEstab;*/
	UW	tcpInSegs;
	UW	tcpOutSegs;
	UW	tcpRetransSegs;
	UW	tcpInErrs;
	UW	tcpOutRsts;
} T_TCP_STATS;

#endif	/* of #ifdef SUPPORT_MIB */

/*
 *  ѿ
 */

extern T_TCP_CREP tcp_crep[];
extern T_TCP_CCEP tcp_ccep[];
extern UB tcp_initialized;
extern const ID tmax_tcp_crepid;
extern const ID tmax_tcp_ccepid;
extern T_TCP_TW_CCEP tcp_tw_ccep[];

#ifdef SUPPORT_MIB

extern T_TCP_STATS tcp_stats;

#endif	/* of #ifdef SUPPORT_MIB */

/*
 *  ؿߥ졼ޥ
 */

#define VALID_TCP_CREPID(id)	(TMIN_TCP_CREPID<=(id)&&(id)<=tmax_tcp_crepid)
#define VALID_TCP_CCEPID(id)	(TMIN_TCP_CCEPID<=(id)&&(id)<=tmax_tcp_ccepid)

#define INDEX_TCP_CREP(id)	((id)-TMIN_TCP_CREPID)
#define INDEX_TCP_CCEP(id)	((id)-TMIN_TCP_CCEPID)

#define GET_TCP_CREP(id)	(&(tcp_crep[INDEX_TCP_CREP(id)]))
#define GET_TCP_CCEP(id)	(&(tcp_ccep[INDEX_TCP_CCEP(id)]))

#define GET_TCP_CREPID(rep)	((ID)(((rep)-tcp_crep)+TMIN_TCP_CREPID))
#define GET_TCP_CCEPID(cep)	((ID)(((cep)-tcp_ccep)+TMIN_TCP_CCEPID))
#define GET_TCP_TW_CCEPID(cep)	((ID)(((cep)-tcp_tw_ccep)+TMIN_TCP_TW_CCEPID))

#define IS_TFN_TCP_RCV(t)	((t)==TFN_TCP_ACP_CEP||(t)==TFN_TCP_RCV_DAT||\
				 (t)==TFN_TCP_CLS_CEP||\
				 (t)==TFN_TCP_RCV_BUF||(t)==TFN_TCP_REL_BUF||\
				 (t)==TFN_TCP_RCV_OOB)

#define VALID_TFN_TCP_CAN(t)	((t)==TFN_TCP_ACP_CEP||(t)==TFN_TCP_CON_CEP||\
				 (t)==TFN_TCP_CLS_CEP||\
				 (t)==TFN_TCP_SND_DAT||(t)==TFN_TCP_RCV_DAT||\
				 (t)==TFN_TCP_GET_BUF||(t)==TFN_TCP_RCV_BUF||\
				 (t)==TFN_TCP_SND_OOB||\
				 (t)==TFN_TCP_ALL)

/*
 *  Inline ؿ
 */

#ifndef TCP_CFG_RWBUF_CSAVE

/*
 *  TCP ̿üμɥХåեξʥԡǽ
 *  ̵ξϲ⤷ʤΥߡδؿ
 */

/*
 *  tcp_free_rwbufq -- ɥХåե塼롣
 */

Inline void
tcp_free_rwbufq_ncs (T_TCP_CCEP *cep)
{
	}

#endif	/* of #ifndef TCP_CFG_RWBUF_CSAVE */

#ifdef TCP_CFG_SWBUF_CSAVE_ONLY

/*
 *  TCP ̿üɥХåեξʥԡǽΤߤ
 *  ͭξϲ⤷ʤΥߡδؿ
 */

/*
 *  tcp_read_swbuf_cs -- ɥХåեǡɤ߽Ф
 */

Inline void
tcp_read_swbuf_cs (T_TCP_CCEP *cep, T_NET_BUF *output, UINT len, UINT doff)
{
	}

#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE_ONLY */

#ifndef TCP_CFG_SWBUF_CSAVE

/*
 *  TCP ̿üɥХåեξʥԡǽ
 *  ̵ξϲ⤷ʤΥߡδؿ
 */

/*
 *  tcp_free_swbufq -- ɥХåե塼롣
 */

Inline void
tcp_free_swbufq_ncs (T_TCP_CCEP *cep)
{
	}

/*
 *  tcp_alloc_swbuf -- ɥХåեѤΥͥåȥХåեγƤؼ롣
 */

Inline void
tcp_alloc_swbuf_ncs (T_TCP_CCEP *cep)
{
	}

/*
 *  tcp_push_res_nbuf -- ͥåȥХåեͽ󤹤롣
 */

Inline T_NET_BUF *
tcp_push_res_nbuf_ncs (T_NET_BUF *nbuf)
{
	return nbuf;
	}

/*
 *  tcp_pull_res_nbuf -- ͽ󤷤ƤͥåȥХåե֤
 */

Inline T_NET_BUF *
tcp_pull_res_nbuf_ncs (ATR nbatr)
{
	return NULL;
	}

#endif	/* of #ifndef TCP_CFG_SWBUF_CSAVE */

/*
 *  TCP ̿üμɥХåեξʥԡǽڤؤޥ
 */

#ifdef TCP_CFG_RWBUF_CSAVE

#ifdef TCP_CFG_RWBUF_CSAVE_ONLY

#define TCP_FREE_RWBUFQ(cep)			tcp_free_rwbufq_cs(cep)
#define TCP_DROP_RWBUF(cep,len)			tcp_drop_rwbuf_cs(cep,len)
#define TCP_READ_RWBUF(cep,data,len)		tcp_read_rwbuf_cs(cep,data,len)
#define TCP_GET_RWBUF_ADDR(cep,buf)		tcp_get_rwbuf_addr_cs(cep,buf)
#define TCP_WRITE_RWBUF(cep,input,thoff)	tcp_write_rwbuf_cs(cep,input,thoff)

#else	/* of #ifdef TCP_CFG_RWBUF_CSAVE_ONLY */

#define TCP_FREE_RWBUFQ(cep)			tcp_free_rwbufq(cep)
#define TCP_DROP_RWBUF(cep,len)			tcp_drop_rwbuf(cep,len)
#define TCP_READ_RWBUF(cep,data,len)		tcp_read_rwbuf(cep,data,len)
#define TCP_GET_RWBUF_ADDR(cep,buf)		tcp_get_rwbuf_addr(cep,buf)
#define TCP_WRITE_RWBUF(cep,input,thoff)	tcp_write_rwbuf(cep,input,thoff)

#endif	/* of #ifdef TCP_CFG_RWBUF_CSAVE_ONLY */

#else	/* of #ifdef TCP_CFG_RWBUF_CSAVE */

#define TCP_FREE_RWBUFQ(cep)			tcp_free_rwbufq_ncs(cep)
#define TCP_DROP_RWBUF(cep,len)			tcp_drop_rwbuf_ncs(cep,len)
#define TCP_READ_RWBUF(cep,data,len)		tcp_read_rwbuf_ncs(cep,data,len)
#define TCP_GET_RWBUF_ADDR(cep,buf)		tcp_get_rwbuf_addr_ncs(cep,buf)
#define TCP_WRITE_RWBUF(cep,input,thoff)	tcp_write_rwbuf_ncs(cep,input,thoff)

#endif	/* of #ifdef TCP_CFG_RWBUF_CSAVE */

/*
 *  TCP ̿üɥХåեξʥԡǽڤؤޥ
 */

#ifdef TCP_CFG_SWBUF_CSAVE

#define TCP_PUSH_RES_NBUF(nbuf)			tcp_push_res_nbuf(nbuf)
#define TCP_PULL_RES_NBUF(atr)			tcp_pull_res_nbuf(atr)

#ifdef TCP_CFG_SWBUF_CSAVE_ONLY

#define TCP_FREE_SWBUFQ(cep)			tcp_free_swbufq_cs(cep)
#define TCP_ALLOC_SWBUF(cep)			tcp_alloc_swbuf_cs(cep)
#define TCP_DROP_SWBUF(cep,len)			tcp_drop_swbuf_cs(cep,len)
#define TCP_WRITE_SWBUF(cep,data,len)		tcp_write_swbuf_cs(cep,data,len)
#define TCP_READ_SWBUF(cep,output,len,doff)	tcp_read_swbuf_cs(cep,output,len,doff)
#define TCP_WAIT_SWBUF(cep,tmout)		tcp_wait_swbuf_cs(cep,tmout)
#define TCP_GET_SWBUF_ADDR(cep,buf)		tcp_get_swbuf_addr_cs(cep,buf)
#define TCP_SEND_SWBUF(cep,len)			tcp_send_swbuf_cs(cep,len)
#define TCP_IS_SWBUF_FULL(cep)			tcp_is_swbuf_full_cs(cep)

#else	/* of #ifdef TCP_CFG_SWBUF_CSAVE_ONLY */

#define TCP_FREE_SWBUFQ(cep)			tcp_free_swbufq(cep)
#define TCP_ALLOC_SWBUF(cep)			tcp_alloc_swbuf(cep)
#define TCP_DROP_SWBUF(cep,len)			tcp_drop_swbuf(cep,len)
#define TCP_WRITE_SWBUF(cep,data,len)		tcp_write_swbuf(cep,data,len)
#define TCP_READ_SWBUF(cep,output,len,doff)	tcp_read_swbuf(cep,output,len,doff)
#define TCP_WAIT_SWBUF(cep,tmout)		tcp_wait_swbuf(cep,tmout)
#define TCP_GET_SWBUF_ADDR(cep,buf)		tcp_get_swbuf_addr(cep,buf)
#define TCP_SEND_SWBUF(cep,len)			tcp_send_swbuf(cep,len)
#define TCP_IS_SWBUF_FULL(cep)			tcp_is_swbuf_full(cep)

#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE_ONLY */

#else	/* of #ifdef TCP_CFG_SWBUF_CSAVE */

#define TCP_READ_SWBUF(cep,output,len,doff)	tcp_read_swbuf_ncs(cep,output,len,doff)
#define TCP_FREE_SWBUFQ(cep)			tcp_free_swbufq_ncs(cep)
#define TCP_ALLOC_SWBUF(cep)			tcp_alloc_swbuf_ncs(cep)
#define TCP_PUSH_RES_NBUF(nbuf)			tcp_push_res_nbuf_ncs(nbuf)
#define TCP_PULL_RES_NBUF(atr)			tcp_pull_res_nbuf_ncs(atr)
#define TCP_DROP_SWBUF(cep,len)			tcp_drop_swbuf_ncs(cep,len)
#define TCP_WRITE_SWBUF(cep,data,len)		tcp_write_swbuf_ncs(cep,data,len)
#define TCP_WAIT_SWBUF(cep,tmout)		tcp_wait_swbuf_ncs(cep,tmout)
#define TCP_GET_SWBUF_ADDR(cep,buf)		tcp_get_swbuf_addr_ncs(cep,buf)
#define TCP_SEND_SWBUF(cep,len)			tcp_send_swbuf_ncs(cep,len)
#define TCP_IS_SWBUF_FULL(cep)			tcp_is_swbuf_full_ncs(cep)

#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */

/*
 *  ؿ
 */

extern UINT tcp_input (T_NET_BUF *input, UINT *offp);
extern void tcp_init (void);
extern void tcp_init_iss (void);
extern T_TCP_CCEP *tcp_close (T_TCP_CCEP *cep);
extern T_TCP_CCEP *tcp_drop  (T_TCP_CCEP *cep, ER errno);
extern void tcp_respond (T_NET_BUF *nbuf, T_TCP_CCEP *cep,
                         T_TCP_SEQ ack, T_TCP_SEQ seq, UINT rbfree, UB flags);
extern void tcp_set_header (T_NET_BUF *nbuf, T_TCP_CCEP *cep, UINT thoff, UINT optlen);
extern ER tcp_get_segment (T_NET_BUF **nbuf, T_TCP_CCEP *cep,
                           UINT optlen, UINT len, UINT maxlen, ATR nbatr, TMO tmout);
extern void tcp_init_cep (T_TCP_CCEP *cep);
extern void tcp_notify (T_NET_BUF *input, int code);
extern T_TCP_TIME tcp_rexmt_val (T_TCP_CCEP *cep);
extern void tcp_set_persist_timer (T_TCP_CCEP *cep);
extern void tcp_cancel_timers (T_TCP_CCEP *cep);
extern void tcp_alloc_auto_port (T_TCP_CCEP *cep);
extern ER tcp_alloc_port (T_TCP_CCEP *cep, UH portno);
extern void tcp_tw_move_cep (T_TCP_CCEP *cep);
extern ER tcp_lock_cep (ID cepid, T_TCP_CCEP **p_cep, FN tfn);
extern void tcp_free_reassq (T_TCP_CCEP *cep);
extern ER tcp_can_send_more (T_TCP_CCEP *cep, FN fncd, TMO tmout);
extern ER tcp_can_recv_more (ER *error, T_TCP_CCEP *cep, FN fncd, TMO tmout);
extern UB tcp_move_ra2rw (T_TCP_CCEP *cep, UB flags);
extern UB tcp_write_raque (T_NET_BUF *input, T_TCP_CCEP *cep, UINT thoff, UB flags);
extern ER tcp_wait_rwbuf (T_TCP_CCEP *cep, TMO tmout);
extern T_TCP_CCEP *tcp_user_closed (T_TCP_CCEP *cep);

/*
 *  TCP ̿üμɥХåեѴؿ
 */

/*
 *  TCP ̿üμɥХåեξʥԡǽͭξ硢
 *  ؿ˻Ѥ롣
 */

extern void tcp_free_rwbufq (T_TCP_CCEP *cep);
extern void tcp_drop_rwbuf (T_TCP_CCEP *cep, UINT len);
extern void tcp_write_rwbuf (T_TCP_CCEP *cep, T_NET_BUF *input, UINT tcpoff);
extern UINT tcp_read_rwbuf (T_TCP_CCEP *cep, VP data, UINT len);
extern UINT tcp_get_rwbuf_addr (T_TCP_CCEP *cep, VP *p_buf);

/*
 *  TCP ̿üμɥХåեξʥԡǽѴؿ
 */

extern void tcp_free_rwbufq_cs (T_TCP_CCEP *cep);
extern void tcp_drop_rwbuf_cs (T_TCP_CCEP *cep, UINT len);
extern void tcp_write_rwbuf_cs (T_TCP_CCEP *cep, T_NET_BUF *input, UINT tcpoff);
extern UINT tcp_read_rwbuf_cs (T_TCP_CCEP *cep, VP data, UINT len);
extern UINT tcp_get_rwbuf_addr_cs (T_TCP_CCEP *cep, VP *p_buf);

/*
 *  TCP ̿üμɥХåեΡ۾ʥԡǽѴؿ
 */

extern void tcp_free_rwbufq_ncs (T_TCP_CCEP *cep);
extern void tcp_drop_rwbuf_ncs (T_TCP_CCEP *cep, UINT len);
extern void tcp_write_rwbuf_ncs (T_TCP_CCEP *cep, T_NET_BUF *input, UINT tcpoff);
extern UINT tcp_read_rwbuf_ncs (T_TCP_CCEP *cep, VP data, UINT len);
extern UINT tcp_get_rwbuf_addr_ncs (T_TCP_CCEP *cep, VP *p_buf);

/*
 *  TCP ̿üɥХåեѴؿ
 */

/*
 *  TCP ̿üɥХåեξʥԡǽͭξ硢
 *  ؿ˻Ѥ롣
 */

extern void tcp_free_swbufq (T_TCP_CCEP *cep);
extern void tcp_drop_swbuf (T_TCP_CCEP *cep, UINT len);
extern ER_UINT tcp_write_swbuf (T_TCP_CCEP *cep, VP data, UINT len);
extern void tcp_read_swbuf (T_TCP_CCEP *cep, T_NET_BUF *output, UINT len, UINT doff);
extern void tcp_send_swbuf (T_TCP_CCEP *cep, UINT len);
extern ER_UINT tcp_get_swbuf_addr (T_TCP_CCEP *cep, VP *p_buf);
extern ER tcp_wait_swbuf (T_TCP_CCEP *cep, TMO tmout);
extern T_NET_BUF *tcp_push_res_nbuf (T_NET_BUF *buf);
extern T_NET_BUF *tcp_pull_res_nbuf (ATR nbatr);
extern void tcp_alloc_swbuf (T_TCP_CCEP *cep);
extern BOOL tcp_is_swbuf_full (T_TCP_CCEP *cep);
extern void tcp_init_swbuf (T_TCP_CCEP *cep);

/*
 *  TCP ̿üɥХåեξʥԡǽѴؿ
 */

extern void tcp_free_swbufq_cs (T_TCP_CCEP *cep);
extern void tcp_drop_swbuf_cs (T_TCP_CCEP *cep, UINT len);
extern ER_UINT tcp_write_swbuf_cs (T_TCP_CCEP *cep, VP data, UINT len);
extern void tcp_read_swbuf_cs (T_TCP_CCEP *cep, T_NET_BUF *output, UINT len, UINT doff);
extern void tcp_send_swbuf_cs (T_TCP_CCEP *cep, UINT len);
extern ER_UINT tcp_get_swbuf_addr_cs (T_TCP_CCEP *cep, VP *p_buf);
extern ER tcp_wait_swbuf_cs (T_TCP_CCEP *cep, TMO tmout);
extern void tcp_alloc_swbuf_cs (T_TCP_CCEP *cep);
extern BOOL tcp_is_swbuf_full_cs (T_TCP_CCEP *cep);

/*
 *  TCP ̿üɥХåեΡ۾ʥԡǽѴؿ
 */

extern void tcp_free_swbufq_ncs (T_TCP_CCEP *cep);
extern void tcp_drop_swbuf_ncs (T_TCP_CCEP *cep, UINT len);
extern ER_UINT tcp_write_swbuf_ncs (T_TCP_CCEP *cep, VP data, UINT len);
extern void tcp_read_swbuf_ncs (T_TCP_CCEP *cep, T_NET_BUF *output, UINT len, UINT doff);
extern void tcp_send_swbuf_ncs (T_TCP_CCEP *cep, UINT len);
extern ER_UINT tcp_get_swbuf_addr_ncs (T_TCP_CCEP *cep, VP *p_buf);
extern ER tcp_wait_swbuf_ncs (T_TCP_CCEP *cep, TMO tmout);
extern T_NET_BUF *tcp_push_res_nbuf_ncs (T_NET_BUF *buf);
extern T_NET_BUF *tcp_pull_res_nbuf_ncs (ATR nbatr);
extern void tcp_alloc_swbuf_ncs (T_TCP_CCEP *cep);
extern BOOL tcp_is_swbuf_full_ncs (T_TCP_CCEP *cep);

/*
 *  tcp_find_cep -- ݡֹ椫 TCP ̿ü롣
 *
 *    : myaddr ϡ
 *          TINET-1.2 ͥåȥХȥ
 *          TINET-1.1 ޤǤϡۥȥХȥ
 */
extern T_TCP_CCEP *tcp_find_cep (T_IN_ADDR *dstaddr, UH dstport,
                                 T_IN_ADDR *peeraddr, UH peerport);

/*
 *  TCP إåΥȥ졼ϵǽѴؿ
 */
extern void tcp_output_trace (T_NET_BUF *output, T_TCP_CCEP *cep);
extern void tcp_input_trace (T_NET_BUF *input, T_TCP_CCEP *cep);

/* TCP ϥ */

extern void	tcp_output_task(VP_INT exinf);

#endif	/* of #ifndef _TCP_VAR_H_ */
