/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_usrreq.c,v 1.3.1.2 2006/07/11 00:56:52 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)udp_usrreq.c	8.6 (Berkeley) 5/23/95
 * $FreeBSD: src/sys/netinet/udp_usrreq.c,v 1.49.2.2 1999/08/29 16:29:58 peter Exp $
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_count.h>
#include <net/ppp_ipcp.h>

#include <netinet/in.h>
#include <netinet6/in6.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip_icmp.h>
#include <netinet6/in6_var.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>
#include <netinet6/nd6.h>
#include <netinet/icmp6.h>
#include <netinet/udp.h>
#include <netinet/udp_var.h>

#ifdef SUPPORT_UDP

/*
 *  IPv4  IPv6 ڤؤޥ
 */

#ifdef SUPPORT_INET4

#define UDP_SND_DAT	udp_snd_dat
#define UDP_RCV_DAT	udp_rcv_dat

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

#define UDP_SND_DAT	udp6_snd_dat
#define UDP_RCV_DAT	udp6_rcv_dat

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  TINET 饤֥경ʤϡƤεǽ
 *  ֥ȥե˽Ϥ뤿ᡢޥͭˤ롣
 */

#ifndef UDP_CFG_LIBRARY

#define __udp_send_data
#define __udp_can_snd
#define __udp_can_rcv
#define __udp_can_cep
#define __udp_snd_dat
#define __udp_rcv_dat

#endif	/* of #ifndef UDP_CFG_LIBRARY */

#ifdef __udp_send_data

/*
 *  udp_send_data -- ѥåμ
 */

ER_UINT
udp_send_data (T_UDP_CCEP *cep, T_IPEP *p_dstaddr, VP data, INT len, TMO tmout)
{
	T_NET_BUF	*output;
	T_UDP_HDR	*udph;
	SYSTIM		before, after;
	ER		error = E_OK;

#ifdef UDP_CFG_OUT_CHECKSUM
	UH	sum;
#endif	/* of #ifdef UDP_CFG_OUT_CHECKSUM */

	NET_COUNT_UDP(net_count_udp.out_octets,  len);
	NET_COUNT_UDP(net_count_udp.out_packets, 1);

	/* IP ǡƤλ֤ tmout 鸺롣*/
	if (!(tmout == TMO_POL || tmout == TMO_FEVR))
		syscall(get_tim(&before));

	/* IP ǡƤ롣*/
	if ((error = IN_GET_DATAGRAM(&output, (UINT)(UDP_HDR_SIZE + len), 0,
	                             &p_dstaddr->ipaddr,
	                             &cep->myaddr.ipaddr,
	                             IPPROTO_UDP, IP_DEFTTL, 
	                             NBA_SEARCH_ASCENT, tmout)) != E_OK)
		goto err_ret;

	/* IP ǡƤλ֤ tmout 鸺롣*/
	if (!(tmout == TMO_POL || tmout == TMO_FEVR)) {
		syscall(get_tim(&after));
		if (after - before > tmout) {
			syscall(rel_net_buf(output));
			error = E_TMOUT;
			goto err_ret;
			}
		tmout -= (TMO)(after - before);
		}

	/* UDP إå˾ꤹ롣*/
	udph		= GET_UDP_HDR(output, IF_IP_UDP_HDR_OFFSET);
	udph->sport	= htons(cep->myaddr.portno);
	udph->dport	= htons(p_dstaddr->portno);
	udph->ulen	= htons(UDP_HDR_SIZE + len);
	udph->sum	= 0;

	/* ǡ򥳥ԡ롣*/
	memcpy((VP)GET_UDP_SDU(output, IF_IP_UDP_HDR_OFFSET), data, (size_t)len);

#ifdef UDP_CFG_OUT_CHECKSUM

	sum = IN_CKSUM(output, IPPROTO_UDP, IF_IP_UDP_HDR_OFFSET, (UINT)(UDP_HDR_SIZE + len));

	/* ׻åͤ 0 ʤ 0xffff 롣*/
	if (sum == 0)
		sum = 0xffff;
	udph->sum = sum;

#endif	/* of #ifdef UDP_CFG_OUT_CHECKSUM */

	/* ͥåȥХåեĹĴ롣*/
	output->len = (UH)(IF_IP_UDP_HDR_SIZE + len);

	/* ͥåȥ (IP) νϴؿƤӽФ*/
	if ((error = IP_OUTPUT(output, tmout)) == E_OK) {
		NET_COUNT_MIB(udp_stats.udpOutDatagrams, 1);
		cep->snd_tskid = TA_NULL;
		return len;
		}

err_ret:
	NET_COUNT_UDP(net_count_udp.out_err_packets, 1);
	cep->snd_tskid = TA_NULL;
	return error;
	}

#endif	/* of #ifdef __udp_send_data */

#ifdef __udp_can_cep

/*
 *  udp_can_cep -- ڥǥ󥰤ƤΥ󥻥ɸൡǽ
 */

ER
udp_can_cep (ID cepid, FN fncd)
{
	T_UDP_CCEP	*cep;
	ER		error = E_OK, snd_err, rcv_err;

	/* API ǽɤå롣*/
	if (!VALID_TFN_UDP_CAN(fncd))
		return E_PAR;

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CCEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CCEP(cepid);

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	if (fncd == TFN_UDP_ALL) {	/* TFN_TCP_ALL ν */

		snd_err = udp_can_snd(cep);
		rcv_err = udp_can_rcv(cep);

		/*
		 *  snd_err  rcv_err Τɤ EV_NOPND
		 *  ʤ顢ڥǥ󥰤ƤʤΤǥ顼
		 */
		if (snd_err == EV_NOPND && rcv_err == EV_NOPND)
			error = E_OBJ;
		else {
			if (snd_err == EV_NOPND)
				snd_err = E_OK;
			if (rcv_err == EV_NOPND)
				rcv_err = E_OK;

			if (snd_err != E_OK)
				error = snd_err;
			else if (rcv_err != E_OK)
				error = rcv_err;
			}
		}
	else if (fncd == TFN_UDP_SND_DAT) {	/* Υ󥻥 */
		if ((error = udp_can_snd(cep)) == EV_NOPND)
			error = E_OBJ;
		}
	else if (fncd == TFN_UDP_RCV_DAT) {	/* Υ󥻥 */
		if ((error = udp_can_rcv(cep)) == EV_NOPND)
			error = E_OBJ;
		}
	else
		error = E_PAR;

	/* ̿üå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

#endif	/* of #ifdef __udp_can_cep */

#ifdef UDP_CFG_NON_BLOCKING

#ifdef __udp_can_snd

/*
 *  udp_can_snd -- ڥǥ󥰤ƤΥ󥻥
 */

ER
udp_can_snd (T_UDP_CCEP *cep)
{
	ER	error = E_OK;

	if (cep->snd_p_dstaddr != NULL) {	/* Υ֥å󥰥ǥڥǥ */
		if (IS_PTR_DEFINED(cep->callback))
			(*cep->callback)(GET_UDP_CCEPID(cep), TFN_UDP_SND_DAT, (VP)E_RLWAI);
		else
			error = E_OBJ;
		cep->snd_p_dstaddr = NULL;
		}
	else if (cep->snd_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */
		error = rel_wai(cep->snd_tskid);
		cep->snd_tskid = TA_NULL;
		}
	else					/* ɤǤʤʤڥǥ󥰤Ƥʤ */
		error = EV_NOPND;

	return error;
	}

#endif	/* of #ifdef __udp_can_snd */

#ifdef __udp_can_rcv

/*
 *  udp_can_rcv -- ڥǥ󥰤ƤΥ󥻥
 */

ER
udp_can_rcv (T_UDP_CCEP *cep)
{
	ER	error = E_OK;

	if (cep->rcv_p_dstaddr != NULL) {	/* Υ֥å󥰥ǥڥǥ */
		if (IS_PTR_DEFINED(cep->callback))
			(*cep->callback)(GET_UDP_CCEPID(cep), TFN_UDP_RCV_DAT, (VP)E_RLWAI);
		else
			error = E_OBJ;
		cep->rcv_p_dstaddr = NULL;
		}
	else if (cep->rcv_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */
		error = rel_wai(cep->rcv_tskid);
		cep->rcv_tskid = TA_NULL;
		}
	else					/* ɤǤʤʤڥǥ󥰤Ƥʤ */
		error = EV_NOPND;

	return error;
	}

#endif	/* of #ifdef __udp_can_rcv */

#ifdef __udp_snd_dat

/*
 *  udp_snd_dat -- ѥåȤɸൡǽ
 */

ER_UINT
UDP_SND_DAT (ID cepid, T_IPEP *p_dstaddr, VP data, INT len, TMO tmout)
{
	T_UDP_CCEP	*cep;
	ER		error;

	/* p_dstaddr ޤ data  NULL ʤ饨顼 */
	if (p_dstaddr == NULL || data == NULL)
		return E_PAR;

	/* ǡĹå롣*/
	if (len < 0 || len + IP_HDR_SIZE + UDP_HDR_SIZE > IF_MTU)
		return E_PAR;

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CCEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CCEP(cepid);

	/*
	 * ॢȤå롣
	 */

	if (tmout == TMO_NBLK) {	/* Υ֥å󥰥 */

		/* ̿üå롣*/
		syscall(wai_sem(cep->semid_lock));

		if (cep->snd_p_dstaddr != NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else if (cep->snd_tskid != TA_NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else {

			cep->snd_p_dstaddr = p_dstaddr;
			cep->snd_data	= data;
			cep->snd_len	= len;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));

			cep->flags |= UDP_CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_UDP_POST_OUTPUT);
			error = E_WBLK;
			}
		}
	else {				/* Υ֥å󥰥 */
	
		/* ̿üå롣*/
		syscall(wai_sem(cep->semid_lock));

		if (cep->snd_p_dstaddr != NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else if (cep->snd_tskid != TA_NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else {

			/* ߤΥ̻ҤϿ롣*/
			get_tid(&(cep->snd_tskid));

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));

			/* ѥåȤ롣*/
			error = udp_send_data(cep, p_dstaddr, data, len, tmout);
			}
		}

	return error;
	}

#endif	/* of #ifdef __udp_snd_dat */

#ifdef __udp_rcv_dat

/*
 *  udp_rcv_dat -- ѥåȤμɸൡǽ
 */

ER_UINT
UDP_RCV_DAT (ID cepid, T_IPEP *p_dstaddr, VP data, INT len, TMO tmout)
{
	T_NET_BUF	*input;
	T_UDP_CCEP	*cep;
	T_UDP_HDR	*udph;
	ER_UINT		error;
	UINT		ulen, uhoff;

	/* p_dstaddr ޤ data  NULL len < 0 ʤ饨顼 */
	if (p_dstaddr == NULL || data == NULL || len < 0)
		return E_PAR;

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CCEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CCEP(cepid);

	/*
	 * ॢȤå롣
	 */

	if (tmout == TMO_NBLK) {	/* Υ֥å󥰥 */

		/* ̿üå롣*/
		syscall(wai_sem(cep->semid_lock));

		if (cep->rcv_p_dstaddr != NULL)

			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;

		else if (cep->rcv_tskid != TA_NULL)

			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;
		else {
			cep->rcv_p_dstaddr = p_dstaddr;
			cep->rcv_data	= data;
			cep->rcv_len	= len;
			error = E_WBLK;
			}

		/* ̿üå롣*/
		syscall(sig_sem(cep->semid_lock));
		return error;
		}
	else {				/* Υ֥å󥰥 */

		/* ̿üå롣*/
		syscall(wai_sem(cep->semid_lock));

		if (cep->rcv_p_dstaddr != NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else if (cep->rcv_tskid != TA_NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else {

			/* ߤΥ̻ҤϿ롣*/
			get_tid(&(cep->rcv_tskid));

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));

			/* ϤޤԤġ*/
			if (IS_PTR_DEFINED(cep->callback)) {
				if ((error = prcv_dtq(cep->cb_rcvqid, (VP_INT*)(VP)&input)) != E_OK) {
					cep->rcv_tskid = TA_NULL;
					return error;
					}
				}
			else if ((error = trcv_dtq(cep->rcvqid, (VP_INT*)(VP)&input, tmout)) != E_OK) {
				cep->rcv_tskid = TA_NULL;
				return error;
				}

			/* p_dstaddr ꤹ롣*/
			uhoff = (UINT)GET_UDP_HDR_OFFSET(input);
			udph = GET_UDP_HDR(input, uhoff);
			p_dstaddr->portno = ntohs(udph->sport);
			IN_COPY_TO_HOST(&p_dstaddr->ipaddr, &GET_IP_HDR(input)->src);

			/* ǡХåե˰ܤ*/
			ulen = ntohs(udph->ulen);
			if (ulen - UDP_HDR_SIZE > len)
				error = E_BOVR;
			else {
				len   =     (INT)(ulen - UDP_HDR_SIZE);
				error = (ER_UINT)(ulen - UDP_HDR_SIZE);
				}

			memcpy(data, GET_UDP_SDU(input, uhoff), (size_t)len);

			syscall(rel_net_buf(input));

			cep->rcv_tskid = TA_NULL;
			}
		return error;
		}
	}

#endif	/* of #ifdef __udp_rcv_dat */

#else /* of #ifdef UDP_CFG_NON_BLOCKING */

#ifdef __udp_can_snd

/*
 *  udp_can_snd -- ڥǥ󥰤ƤΥ󥻥
 */

ER
udp_can_snd (T_UDP_CCEP *cep)
{
	ER	error = E_OK;

	if (cep->snd_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */
		error = rel_wai(cep->snd_tskid);
		cep->snd_tskid = TA_NULL;
		}
	else					/* ɤǤʤʤڥǥ󥰤Ƥʤ */
		error = EV_NOPND;

	return error;
	}

#endif	/* of #ifdef __udp_can_snd */

#ifdef __udp_can_rcv

/*
 *  udp_can_rcv -- ڥǥ󥰤ƤΥ󥻥
 */

ER
udp_can_rcv (T_UDP_CCEP *cep)
{
	ER	error = E_OK;

	if (cep->rcv_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */
		error = rel_wai(cep->rcv_tskid);
		cep->rcv_tskid = TA_NULL;
		}
	else					/* ɤǤʤʤڥǥ󥰤Ƥʤ */
		error = EV_NOPND;

	return error;
	}

#endif	/* of #ifdef __udp_can_rcv */

#ifdef __udp_snd_dat

/*
 *  udp_snd_dat -- ѥåȤɸൡǽ
 */

ER_UINT
UDP_SND_DAT (ID cepid, T_IPEP *p_dstaddr, VP data, INT len, TMO tmout)
{
	T_UDP_CCEP	*cep;
	ER		error;

	/* p_dstaddr ޤ data  NULL tmout  TMO_NBLK ʤ饨顼 */
	if (p_dstaddr == NULL || data == NULL || tmout == TMO_NBLK)
		return E_PAR;

	/* ǡĹå롣*/
	if (len < 0 || len + IP_HDR_SIZE + UDP_HDR_SIZE > IF_MTU)
		return E_PAR;

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CCEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CCEP(cepid);
	
	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	if (cep->snd_tskid != TA_NULL) {

		/* Υ֥å󥰥ǥڥǥ */
		error = E_QOVR;

		/* ̿üå롣*/
		syscall(sig_sem(cep->semid_lock));
		}
	else {
		/* ߤΥ̻ҤϿ롣*/
		get_tid(&(cep->snd_tskid));

		/* ̿üå롣*/
		syscall(sig_sem(cep->semid_lock));

		/* ѥåȤ롣*/
		error = udp_send_data(cep, p_dstaddr, data, len, tmout);
		}

	return error;
	}

#endif	/* of #ifdef __udp_snd_dat */

#ifdef __udp_rcv_dat

/*
 *  udp_rcv_dat -- ѥåȤμɸൡǽ
 */

ER_UINT
UDP_RCV_DAT (ID cepid, T_IPEP *p_dstaddr, VP data, INT len, TMO tmout)
{
	T_NET_BUF	*input;
	T_UDP_CCEP	*cep;
	T_UDP_HDR	*udph;
	ER_UINT		error;
	UINT		ulen, uhoff;

	/* p_dstaddr ޤ data  NULL len < 0 tmout  TMO_NBLK ʤ饨顼 */
	if (p_dstaddr == NULL || data == NULL || len < 0 || tmout == TMO_NBLK)
		return E_PAR;

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CCEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CCEP(cepid);

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	if (cep->rcv_tskid != TA_NULL) {

		/* Υ֥å󥰥ǥڥǥ */
		error = E_QOVR;

		/* ̿üå롣*/
		syscall(sig_sem(cep->semid_lock));
		}
	else {

		/* ߤΥ̻ҤϿ롣*/
		get_tid(&(cep->rcv_tskid));

		/* ̿üå롣*/
		syscall(sig_sem(cep->semid_lock));

		/* ϤޤԤġ*/
		if (IS_PTR_DEFINED(cep->callback)) {
			if ((error = prcv_dtq(cep->cb_rcvqid, (VP_INT*)(VP)&input)) != E_OK) {
				cep->rcv_tskid = TA_NULL;
				return error;
				}
			}
		else if ((error = trcv_dtq(cep->rcvqid, (VP_INT*)(VP)&input, tmout)) != E_OK) {
			cep->rcv_tskid = TA_NULL;
			return error;
			}

		/* p_dstaddr ꤹ롣*/
		uhoff = (UINT)GET_UDP_HDR_OFFSET(input);
		udph = GET_UDP_HDR(input, uhoff);
		p_dstaddr->portno = ntohs(udph->sport);
		IN_COPY_TO_HOST(&p_dstaddr->ipaddr, &GET_IP_HDR(input)->src);

		/* ǡХåե˰ܤ*/
		ulen = ntohs(udph->ulen);
		if (ulen - UDP_HDR_SIZE > len)
			error = E_BOVR;
		else {
			len   =    (UINT)(ulen - UDP_HDR_SIZE);
			error = (ER_UINT)(ulen - UDP_HDR_SIZE);
			}

		memcpy(data, GET_UDP_SDU(input, uhoff), (size_t)len);

		syscall(rel_net_buf(input));

		cep->rcv_tskid = TA_NULL;
		}

	return error;
	}

#endif	/* of #ifdef __udp_rcv_dat */

#endif	/* of #ifdef UDP_CFG_NON_BLOCKING */

#endif	/* of #ifdef SUPPORT_UDP */
